#ifdef _WIN_IOT
// For communicating to C++/CX
#undef boolean
#define boolean bool
#endif

#define MAX_LEN 512
unsigned int data[MAX_LEN];
int dataPos;

boolean needSend = false;

boolean getSignal(unsigned int **sdata, int *dataLen)
{
	if (needSend == true) {
		*sdata = data;
		*dataLen = dataPos;
	} else {
		*sdata = NULL;
		*dataLen = 0;
	}
	return needSend;
}

// --------------

const int modulePin = GPIO_17;
const long waitMicros = 1000000;

unsigned long lastMicros;
int moduleStatus, totalMS;

void resetSignal()
{
	dataPos = 0;
	totalMS = 0;
	needSend = false;
	lastMicros = micros();
}

void setup() {
	pinMode(modulePin, INPUT);
	moduleStatus = HIGH;

	resetSignal();
}

boolean waitSignal()
{
	unsigned long waitStartMicros = micros();
	while (digitalRead(modulePin) == moduleStatus) {
		if (micros() - waitStartMicros > waitMicros) return true;
		delayMicroseconds(100);
	}
	return false;
}

void loop() {
	if (dataPos >= MAX_LEN || waitSignal() == true) {
		if (totalMS > 4000) {	//45msec
			needSend = true;
		}
		return;
	}

	unsigned long now = micros();

	int sc = (now - lastMicros) / 10;
	if (dataPos > 0) totalMS += sc;
	data[dataPos++] = sc;

	lastMicros = now;

	moduleStatus = !moduleStatus;
}
